!==================================================================================
!       .
!  , ., 2016 .
!==================================================================================

                     MEMBER

   INCLUDE('fsDisplCust.INC')

   MAP
     INCLUDE('BUILTINS.CLW'),ONCE   ! RTL
     MODULE('')
       SLEEP(LONG),PASCAL
     END
   END

!===================================================================================
!  
!
FsDisplCust.Init PROCEDURE (LONG pContr, BYTE pIndex) 
      CODE

   if SELF.Active=1
      return
   end

   if pContr=0
      return
   end

   SELF.Contr = pContr

   SELF.Contr{PROP:Create} ='DrvDspl.v1_2'
   if SELF.Contr{PROP:OLE}=false and SELF.Contr{PROP:Object} = ''
      SELF.ErrorCode=-1
      SELF.ErrorDisc='     !'
      return 
   end

   SELF.Active=1

   if pIndex<>0    !  
      SELF.Contr{'CurrentDeviceIndex'}=pIndex
      SELF.GetResultCode 
   end

!===================================================================================
!  
!
FsDisplCust.Kill PROCEDURE
      CODE
   if SELF.Active=0
      return
   end

   SELF.Active=0
   SELF.Contr{PROP:Deactivate}

!===================================================================================
!
!  
!
FsDisplCust.Destruct PROCEDURE
   CODE
      SELF.Kill

!===================================================================================
!
!  
!
FsDisplCust.GetResultCode PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.ErrorCode = SELF.Contr{'ResultCode'}
   SELF.ErrorDisc = SELF.Contr{'ResultCodeDescriptor'}

!===================================================================================
!
!   
!
FsDisplCust.GetDrvProperty FUNCTION (STRING pName)
loc:prop  string(128)
   CODE

   if SELF.Active=0
      return('')
   end

   loc:prop = SELF.Contr{' & clip(pName) & '}
   return(loc:prop)

!===================================================================================
!
!  
!
FsDisplCust.Enable PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'Enable'}=1
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.Disable PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'Enable'}=0
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.ClearDispl PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'ClearDispl()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.ShowVisual PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'ShowVisual()'}
   SELF.GetResultCode

!===================================================================================
!
! 
!
FsDisplCust.SelfTest PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'SelfTest()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.Test PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'Test()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.InitialDispl PROCEDURE
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'InitialDispl()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.SetBrightness PROCEDURE (BYTE pReg)
   CODE

   if SELF.Active=0
      return
   end

   case pReg
      of 40
        SELF.Contr{'Brightness'} = 1
      of 60
        SELF.Contr{'Brightness'} = 2
      of 80
        SELF.Contr{'Brightness'} = 3
      of 100
        SELF.Contr{'Brightness'} = 4
      else
        return
   end 

   SELF.GetResultCode

!===================================================================================
!
! / 
!
FsDisplCust.SetGetAnnun PROCEDURE (BYTE pReg, BYTE pPoz)
   CODE

   if SELF.Active=0
      return
   end

   if pReg=0     !  
      SELF.Contr{'SetGetAnnun(0,' & pPoz & ')'}
   elsif pReg=1  !
      SELF.Contr{'SetGetAnnun(1,' & pPoz & ')'}
   elsif pReg=2  ! 
      SELF.Contr{'ClearAllAnnun()'}
   else
      return 
   end

   SELF.GetResultCode

!===================================================================================
!
! 
!
FsDisplCust.SetBlinc PROCEDURE (BYTE pInterval)
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'BlincInterval'} = pInterval
   SELF.GetResultCode

!===================================================================================
!
!   
!
FsDisplCust.SendLine PROCEDURE  (STRING pStr)
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'SendLine(''' & clip(pStr) & ''')'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.CursEnable PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'Cursor'} = 1
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.CursDisable PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'Cursor'} = 0
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.CursRight PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorRight()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.CursLeft PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorLeft()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.CursDown PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorDown()'}
   SELF.GetResultCode

!===================================================================================
!
!  
!
FsDisplCust.CursUp PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorUp()'}
   SELF.GetResultCode

!===================================================================================
!
!   
!
FsDisplCust.CursDownUp PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorDownUp()'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.CursInBeg PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorInBeg()'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.CursInEndStr PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorInEndStr()'}
   SELF.GetResultCode

!===================================================================================
!
!     
!
FsDisplCust.CursInStartText PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorInBegText()'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.CursInEndText PROCEDURE 
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorInEndText()'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.CursGoTo PROCEDURE  (BYTE pPoz)
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'CursorGoTo(' & pPoz & ')'}
   SELF.GetResultCode

!===================================================================================
!
!   
!
FsDisplCust.CursClearLine PROCEDURE  
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'ClearCursorLine'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.EnterStr PROCEDURE  (STRING pStr, BYTE pPoz)
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'EnterStr(' & pPoz & ',' & clip(pStr) & ')'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.RunStr PROCEDURE  (STRING pStr, BYTE pNum, LONG pRefr, LONG pCycles, LONG pPause, LONG pInterval)
   CODE

   if SELF.Active=0
      return
   end

   if pNum<>1 and pNum<>2
      return
   end

   SELF.Contr{'StartRunString(' & clip(pStr) & ',' & pNum & ',' & pRefr & ',' & pCycles & ',' & pPause & ',' & pInterval & ')'}
   SELF.GetResultCode

!===================================================================================
!
!   
!
FsDisplCust.StopStr PROCEDURE  (BYTE pNum)
   CODE

   if SELF.Active=0
      return
   end

   if pNum<>1 and pNum<>2
      return
   end

   SELF.Contr{'StopRunString(' & pNum & ')'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.GetRunStrState PROCEDURE  (BYTE pNum)
   CODE

   if SELF.Active=0
      return
   end

   if pNum<>1 and pNum<>2
      return
   end

   SELF.Contr{'GetRunStrState(' & pNum & ')'}
   SELF.GetResultCode

!===================================================================================
!
!    
!
FsDisplCust.SelfRunStr PROCEDURE  (STRING pStr)
   CODE

   if SELF.Active=0
      return
   end

   SELF.Contr{'SelfRunString(''' & clip(pStr) & ''')'}
   SELF.GetResultCode 

!===================================================================================
!
!   
!
FsDisplCust.ChangeProtocol PROCEDURE  (BYTE pNum)
   CODE

   if SELF.Active=0
      return
   end

   if pNum<>0 and pNum<>1   !0 - Datecs, 1 - Firich
      return
   end 

   SELF.Contr{'SMChangeProtocol(' & pNum & ')'}
   SELF.GetResultCode 

!===================================================================================
!
!   
!
FsDisplCust.SetScreenSizeMode PROCEDURE  (BYTE pNum)
   CODE

   if SELF.Active=0
      return
   end

   if pNum<>0 and pNum<>1   !0 - 20   , 1 - 22   
      return
   end 

   SELF.Contr{'SMSetScreenSizeMode(' & pNum & ')'}
   SELF.GetResultCode 

!===================================================================================
!
!   
!
FsDisplCust.SetCodeSymbolInDispl PROCEDURE  (BYTE pNum)
   CODE

   if SELF.Active=0
      return
   end

   if pNum<>0 and pNum<>1   !0 - pc850  Datecs, dos866  Firich, 1 - win1251
      return
   end 

   SELF.Contr{'SMSetCodeSymbolInDispl(' & pNum & ')'}
   SELF.GetResultCode 

!===================================================================================
!
!   
!
FsDisplCust.SetBaudRate PROCEDURE  (BYTE pNum)
   CODE

   if SELF.Active=0
      return
   end

   if ~(pNum>0 and pNum<9)
      return
   end 

   ! 1 = 2400
   ! 2 = 4800
   ! 3 = 9600
   ! 4 = 14400
   ! 5 = 19200
   ! 6 = 38400
   ! 7 = 57600
   ! 8 = 115200

   SELF.Contr{'SMSetBaudRate(' & pNum & ')'}
   SELF.GetResultCode 


!===================================================================================
!
!    
!
FsDisplCust.SaleDispl PROCEDURE  (REAL pSum, REAL pSumIt, STRING pName)
loc:str1    string(20)
loc:str2    string(20)
loc:strSum  string(20)
loc:dl      long 
   CODE

   if SELF.Active=0
      return
   end

   loc:strSum = left(format(pSum,@n-12.2))
   loc:dl     = 19 - len(clip(loc:strSum))
   loc:str1   = sub(clip(pName) & all(' ',20),1,loc:dl) & ' ' & loc:strSum

   loc:strSum = left(format(pSumIt,@n-12.2))
   loc:dl     = 19 - len(clip(loc:strSum))
   loc:str2   = sub(':' & all(' ',20),1,loc:dl) & ' ' & loc:strSum

   SELF.StopStr(1)
   SELF.StopStr(2)
   sleep(200)
   SELF.ClearDispl()
   SELF.EnterStr(clip(loc:str1) & clip(loc:str2),1)

   SELF.GetResultCode 

!===================================================================================
!
!     
!
FsDisplCust.SalePause PROCEDURE  (STRING pStr1, STRING pStr2)
   CODE

   if SELF.Active=0
      return
   end

   SELF.StopStr(1)
   SELF.StopStr(2)
   SELF.ClearDispl()

   SELF.RunStr(clip(pStr1),1,2,100,2,2)
   SELF.RunStr(clip(pStr2),2,2,100,2,2)

   SELF.GetResultCode 
